//+------------------------------------------------------------------+
//|                                                stoch crosses.mq4 |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  clrLime
#property indicator_color2  clrRed


extern int    KPeriod          = 5;
extern int    DPeriod          = 3;
extern int    Slowing          = 3;
extern ENUM_MA_METHOD MA_Method  = MODE_SMA;
extern ENUM_STO_PRICE PriceField = 0;
extern bool   show_KD_cross    = false;
extern bool   show_K_OBOScross = true;
extern bool   show_D_OBOScross = false;
extern double OverBoughtLevel  = 80;
extern double OverSoldLevel    = 20;
extern string note             = "turn on Alert = true";
extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = true;
extern bool   alertsEmail      = false;
extern bool   alertsNotify     = false;
extern string soundfile        = "alert2.wav";
extern int    ArrowCodeUp      = 241;      // Arrow code up
extern int    ArrowCodeDn      = 242;      // Arrow code down
extern double ArrowGapUp       = 0.5;      // Gap for arrow up        
extern double ArrowGapDn       = 0.5;      // Gap for arrow down
//
//
//
//
//

double CrossUp[];
double CrossDn[];
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
{
   IndicatorBuffers(3);   
   SetIndexBuffer(0, CrossUp);  SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,ArrowCodeUp);
   SetIndexBuffer(1, CrossDn);  SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,ArrowCodeDn);
   SetIndexBuffer(2, trend);     
   IndicatorShortName("Stoch Cross ");
return(0);
}

int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int start() {
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
      for(i=limit; i>=0; i--)
      {
         double stoNow = iStochastic(NULL,0,KPeriod,DPeriod,Slowing,MA_Method,PriceField,MODE_MAIN,i);
         double stoPre = iStochastic(NULL,0,KPeriod,DPeriod,Slowing,MA_Method,PriceField,MODE_MAIN,i+1);
         double sigNow = iStochastic(NULL,0,KPeriod,DPeriod,Slowing,MA_Method,PriceField,MODE_SIGNAL,i);
         double sigPre = iStochastic(NULL,0,KPeriod,DPeriod,Slowing,MA_Method,PriceField,MODE_SIGNAL,i+1);
         
         trend[i] = trend[i+1];
         if (((show_KD_cross)    && (stoNow > sigNow)          && (stoPre < sigPre))          || 
             ((show_K_OBOScross) && (stoNow > OverSoldLevel)   && (stoPre < OverSoldLevel))   ||
             ((show_D_OBOScross) && (sigNow > OverSoldLevel)   && (sigPre < OverSoldLevel)))  trend[i] = 1;
         if (((show_KD_cross)    && (stoNow < sigNow)          && (stoPre > sigPre))          || 
             ((show_K_OBOScross) && (stoNow < OverBoughtLevel) && (stoPre > OverBoughtLevel)) ||
             ((show_D_OBOScross) && (sigNow < OverBoughtLevel) && (sigPre > OverBoughtLevel)))trend[i] =-1;
         
         //
         //
         //
         //
         //
         
         CrossUp[i] = EMPTY_VALUE;
         CrossDn[i] = EMPTY_VALUE;
         if (trend[i] !=trend[i+1])
         if (trend[i] == 1)
               CrossUp[i] = Low[i] - iATR(NULL,0,15,i)*ArrowGapUp;
         else  CrossDn[i] = High[i]+ iATR(NULL,0,15,i)*ArrowGapDn;
    }
    
    //
    //
    //
    //
    //
    
    if (alertsOn)
    {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"buy");
         if (trend[whichBar] ==-1) doAlert(whichBar,"sell");
      }         
   }
return(0);
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

        message =  StringConcatenate(Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" Stochastic Cross "+doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Stochastic Cross "),message);
          if (alertsNotify)  SendNotification(message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}